3 # Update a local Subversion, Git or Mercurial tree from the GCC
4 # repository, with an emphasis on treating generated files correctly, so
5 # that autoconf, gperf et al are not required for the ``end'' user.
7 # (C) 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2009,
8 # 2010, 2011, 2012, 2013, 2014, 2015, 2017 Free Software Foundation
9 # Originally by Gerald Pfeifer <gerald@pfeifer.com>, August 1998.
11 # This script is Free Software, and it can be copied, distributed and
12 # modified as defined in the GNU General Public License. A copy of
13 # its license can be downloaded from http://www.gnu.org/copyleft/gpl.html
16 # By default all command-line options are passed to `svn update` or `hg/git
17 # pull` in addition to $UPDATE_OPTIONS (defined below). If the first parameter
18 # reads --nostdflags, $UPDATE_OPTIONS as well as this parameter itself
21 # If the first parameter reads --patch, the second parameter is considered
24 # If the first parameter is --touch, no svn operation will be performed,
25 # only generated files that appear to be out of date in the local tree
28 # If the first parameter is --list, a list of the generated files and
29 # their dependencies will be printed; --help prints this message.
31 # If the first parameter is --silent, this script prints nothing other
32 # than error messages; the second parameter is then interpreted as above.
36 # contrib/gcc_update -r 8712
37 # contrib/gcc_update --patch some-patch
38 # contrib/gcc_update --touch
39 # contrib/gcc_update --list
42 # Default options used when updating (none).
45 # Set the locale to C to make this script work for users with foreign
46 # locale like e.g. French UTF-8.
51 ######## Anything below shouldn't be changed by regular users.
53 # Arrange for the value of $0 to be available for functions
56 # This function prints its arguments to standard output unless
60 if [ -z "$silent" ]; then
65 # This function prints a list of all generated files, along with their
66 # dependencies. Note that only one target is supported per line: the
67 # colon is stripped from the output.
68 files_and_dependencies
() {
69 sed -e 's/ *#.*//' -e '/^$/d' -e 's/://' <<\EOF
71 fixincludes
/configure
: fixincludes
/configure.ac fixincludes
/aclocal.
m4
72 fixincludes
/config.h.
in: fixincludes
/configure.ac fixincludes
/aclocal.
m4
74 intl
/plural.c
: intl
/plural.y
75 intl
/configure
: intl
/configure.ac intl
/aclocal.
m4
76 intl
/config.h.
in: intl
/configure.ac intl
/aclocal.
m4
77 # Now, proceed to gcc automatically generated files
78 gcc
/configure
: gcc
/configure.ac
79 gcc
/cstamp-h.
in: gcc
/configure.ac
80 gcc
/config.
in: gcc
/cstamp-h.
in
81 gcc
/fixinc
/fixincl.x
: gcc
/fixinc
/fixincl.tpl gcc
/fixinc
/inclhack.def
82 gcc
/config
/aarch64
/aarch64-tune.md
: gcc
/config
/aarch64
/aarch64-cores.def gcc
/config
/aarch64
/gentune.sh
83 gcc
/config
/arm
/arm-tune.md
: gcc
/config
/arm
/arm-cpus.
in gcc
/config
/arm
/parsecpu.
awk
84 gcc
/config
/arm
/arm-tables.opt
: gcc
/config
/arm
/arm-cpus.
in gcc
/config
/arm
/parsecpu.
awk
85 gcc
/config
/arm
/arm-cpu.h
: gcc
/config
/arm
/arm-cpus.
in gcc
/config
/arm
/parsecpu.
awk
86 gcc
/config
/arm
/arm-cpu-data.h
: gcc
/config
/arm
/arm-cpus.
in gcc
/config
/arm
/parsecpu.
awk
87 gcc
/config
/arm
/arm-cpu-cdata.h
: gcc
/config
/arm
/arm-cpus.
in gcc
/config
/arm
/parsecpu.
awk
88 gcc
/config
/avr
/avr-tables.opt
: gcc
/config
/avr
/avr-mcus.def gcc
/config
/avr
/genopt.sh
89 gcc
/config
/avr
/t-multilib
: gcc
/config
/avr
/avr-mcus.def gcc
/config
/avr
/genmultilib.
awk
90 gcc
/config
/c6x
/c6x-tables.opt
: gcc
/config
/c6x
/c6x-isas.def gcc
/config
/c6x
/genopt.sh
91 gcc
/config
/c6x
/c6x-sched.md
: gcc
/config
/c6x
/c6x-sched.md.
in gcc
/config
/c6x
/gensched.sh
92 gcc
/config
/c6x
/c6x-mult.md
: gcc
/config
/c6x
/c6x-mult.md.
in gcc
/config
/c6x
/genmult.sh
93 gcc
/config
/m68k
/m68k-tables.opt
: gcc
/config
/m68k
/m68k-devices.def gcc
/config
/m68k
/m68k-isas.def gcc
/config
/m68k
/m68k-microarchs.def gcc
/config
/m68k
/genopt.sh
94 gcc
/config
/mips
/mips-tables.opt
: gcc
/config
/mips
/mips-cpus.def gcc
/config
/mips
/genopt.sh
95 gcc
/config
/rs6000
/rs6000-tables.opt
: gcc
/config
/rs6000
/rs6000-cpus.def gcc
/config
/rs6000
/genopt.sh
96 gcc
/config
/tilegx
/mul-tables.c
: gcc
/config
/tilepro
/gen-mul-tables.cc
97 gcc
/config
/tilepro
/mul-tables.c
: gcc
/config
/tilepro
/gen-mul-tables.cc
98 # And then, language-specific files
99 gcc
/cp
/cfns.h
: gcc
/cp
/cfns.gperf
101 # Without this, _Pragma3.c can have a false negative.
102 gcc
/testsuite
/gcc.dg
/cpp
/_Pragma3.c
: gcc
/testsuite
/gcc.dg
/cpp
/mi1c.h
103 # Similarly, without this, you will see:
104 # direct2s.c:35: warning: current file is older than direct2.c
105 gcc
/testsuite
/gcc.dg
/cpp
/direct2s.c
: gcc
/testsuite
/gcc.dg
/cpp
/direct2.c
107 lto-plugin
/configure
: lto-plugin
/configure.ac lto-plugin
/aclocal.
m4
108 lto-plugin
/Makefile.
in: lto-plugin
/Makefile.am lto-plugin
/aclocal.
m4
109 # And libraries, at last
110 libbanshee
/configure
: libbanshee
/configure.ac
111 libmudflap
/configure
: libmudflap
/configure.ac
112 libobjc
/configure
: libobjc
/configure.ac
113 zlib
/aclocal.
m4: zlib
/configure.ac zlib
/acinclude.
m4
114 zlib
/Makefile.
in: zlib
/Makefile.am zlib
/configure.ac zlib
/aclocal.
m4
115 zlib
/configure
: zlib
/configure.ac zlib
/aclocal.
m4
116 fastjar
/aclocal.
m4: fastjar
/configure.ac
117 fastjar
/Makefile.
in: fastjar
/Makefile.am fastjar
/configure.ac fastjar
/aclocal.
m4
118 fastjar
/configure
: fastjar
/configure.ac fastjar
/aclocal.
m4
119 boehm-gc
/aclocal.
m4: boehm-gc
/configure.ac
120 boehm-gc
/Makefile.
in: boehm-gc
/Makefile.am boehm-gc
/configure.ac boehm-gc
/aclocal.
m4
121 boehm-gc
/configure
: boehm-gc
/configure.ac boehm-gc
/aclocal.
m4
122 libada
/configure
: libada
/configure.ac
123 libffi
/aclocal.
m4: libffi
/configure.ac libffi
/acinclude.
m4
124 libffi
/Makefile.
in: libffi
/Makefile.am libffi
/configure.ac libffi
/aclocal.
m4
125 libffi
/configure
: libffi
/configure.ac libffi
/aclocal.
m4
126 libffi
/fficonfig.h.
in: libffi
/configure.ac libffi
/aclocal.
m4
127 libgfortran
/aclocal.
m4: libgfortran
/configure.ac libgfortran
/acinclude.
m4
128 libgfortran
/Makefile.
in: libgfortran
/Makefile.am libgfortran
/configure.ac libgfortran
/aclocal.
m4
129 libquadmath
/configure
: libquadmath
/configure.ac libquadmath
/aclocal.
m4
130 libquadmath
/aclocal.
m4: libquadmath
/configure.ac libquadmath
/acinclude.
m4
131 libquadmath
/Makefile.
in: libquadmath
/Makefile.am libquadmath
/configure.ac libgfortran
/aclocal.
m4
132 libgfortran
/configure
: libgfortran
/configure.ac libgfortran
/aclocal.
m4
133 libcpp
/aclocal.
m4: libcpp
/configure.ac
134 libcpp
/Makefile.
in: libcpp
/configure.ac libcpp
/aclocal.
m4
135 libcpp
/configure
: libcpp
/configure.ac libcpp
/aclocal.
m4
136 libgomp
/aclocal.
m4: libgomp
/configure.ac libgomp
/acinclude.
m4
137 libgomp
/Makefile.am
: libgomp
/plugin
/Makefrag.am
138 libgomp
/Makefile.
in: libgomp
/Makefile.am libgomp
/aclocal.
m4
139 libgomp
/testsuite
/Makefile.
in: libgomp
/testsuite
/Makefile.am libgomp
/aclocal.
m4
140 libgomp
/configure.ac
: libgomp
/plugin
/configfrag.ac
141 libgomp
/configure
: libgomp
/configure.ac libgomp
/aclocal.
m4
142 libgomp
/config.h.
in: libgomp
/configure.ac libgomp
/aclocal.
m4
143 libhsail-rt
/aclocal.
m4: libhsail-rt
/configure.ac
144 libhsail-rt
/Makefile.
in: libhsail-rt
/Makefile.am libhsail-rt
/aclocal.
m4
145 libhsail-rt
/configure
: libhsail-rt
/configure.ac libhsail-rt
/aclocal.
m4
146 libhsail-rt
/target-config.h.
in: libhsail-rt
/configure.ac libhsail-rt
/aclocal.
m4
147 libitm
/aclocal.
m4: libitm
/configure.ac libitm
/acinclude.
m4
148 libitm
/Makefile.
in: libitm
/Makefile.am libitm
/aclocal.
m4
149 libitm
/testsuite
/Makefile.
in: libitm
/testsuite
/Makefile.am libitm
/aclocal.
m4
150 libitm
/configure
: libitm
/configure.ac libitm
/aclocal.
m4
151 libitm
/config.h.
in: libitm
/configure.ac libitm
/aclocal.
m4
152 libatomic
/aclocal.
m4: libatomic
/configure.ac libatomic
/acinclude.
m4
153 libatomic
/Makefile.
in: libatomic
/Makefile.am libatomic
/aclocal.
m4
154 libatomic
/testsuite
/Makefile.
in: libatomic
/testsuite
/Makefile.am libatomic
/aclocal.
m4
155 libatomic
/configure
: libatomic
/configure.ac libatomic
/aclocal.
m4
156 libatomic
/auto-config.h.
in: libatomic
/configure.ac libatomic
/aclocal.
m4
157 libsanitizer
/aclocal.
m4: libsanitizer
/configure.ac libsanitizer
/acinclude.
m4
158 libsanitizer
/Makefile.
in: libsanitizer
/Makefile.am libsanitizer
/aclocal.
m4
159 libsanitizer
/configure
: libsanitizer
/configure.ac libsanitizer
/aclocal.
m4
160 libsanitizer
/asan
/Makefile.
in: libsanitizer
/asan
/Makefile.am libsanitizer
/aclocal.
m4
161 libsanitizer
/interception
/Makefile.
in: libsanitizer
/interception
/Makefile.am libsanitizer
/aclocal.
m4
162 libsanitizer
/sanitizer_common
/Makefile.
in: libsanitizer
/sanitizer_common
/Makefile.am libsanitizer
/aclocal.
m4
163 libvtv
/aclocal.
m4: libvtv
/configure.ac libvtv
/acinclude.
m4
164 libvtv
/Makefile.
in: libvtv
/Makefile.am libvtv
/aclocal.
m4
165 libvtv
/configure
: libvtv
/configure.ac libvtv
/aclocal.
m4
166 libcilkrts
/aclocal.
m4: libcilkrts
/configure.ac
167 libcilkrts
/Makefile.
in: libcilkrts
/Makefile.am
168 libcilkrts
/configure
: libcilkrts
/configure.ac
169 liboffloadmic
/aclocal.
m4: liboffloadmic
/configure.ac
170 liboffloadmic
/Makefile.
in: liboffloadmic
/Makefile.am
171 liboffloadmic
/configure
: liboffloadmic
/configure.ac
172 liboffloadmic
/plugin
/aclocal.
m4: liboffloadmic
/plugin
/configure.ac
173 liboffloadmic
/plugin
/Makefile.
in: liboffloadmic
/plugin
/Makefile.am
174 liboffloadmic
/plugin
/configure
: liboffloadmic
/plugin
/configure.ac
176 Makefile.
in: Makefile.tpl Makefile.def
177 configure
: configure.ac config
/acx.
m4
182 # This function touches generated files such that the ``end'' user does
183 # not have to rebuild them.
186 echo 'all: \' > Makefile.$$
187 files_and_dependencies | sed 's
, .
*, \\,' >> Makefile.$$
188 echo '; @true
' >> Makefile.$$
189 files_and_dependencies | sed 's
, ,: ,' >> Makefile.$$
190 files_and_dependencies | sed 's
, .
*, \\,' >> Makefile.$$
191 echo ':' >> Makefile.$$
192 echo ' @
for f
in $? $@
; do test -f $
$f ||
exit 0; done; \' >> Makefile.$$
193 echo ' echo Touching $@...; \' >> Makefile.$$
194 chat ' echo Touching $@...
1>&2; \' >> Makefile.$$
195 echo ' touch $@' >> Makefile.$$
196 files_and_dependencies |
sed 's,[^ ]* ,,;s,$, :,' >> Makefile.$$
198 # We would have to explicitly shut off the "Entering... Leaving..."
199 # messages through "--no-print-directory" to handle the case when
200 # we were called from a recursive invocation (i.e. "$(MAKE)" in a
201 # Makefile, not just make). Passing only "-s" doesn't help then,
202 # because make has helpfully added "-w" to MAKEFLAGS automatically.
203 # Unfortunately we do not require GNU make other than for building
204 # and testing, so let's just grep known text explicitly echoed by
206 while ${MAKE-make} -s -f Makefile.$$ all |
grep Touching
> /dev
/null
; do
213 # Whenever we update the tree or install a patch, we may be modifying
214 # this script. By re-execing it, we ensure that the appropriate
215 # dependencies and rules will be used.
216 touch_files_reexec
() {
217 chat
"Adjusting file timestamps"
218 exec ${CONFIG_SHELL-/bin/sh} $self ${silent+"--silent"} --touch
221 # This functions applies a patch to an existing tree.
224 echo "Applying patch file $1"
227 gzip -d -c "$1" |
patch -p1 ;;
229 bzip2 -d -c "$1" |
patch -p1 ;;
237 # Check whether this indeed looks like a local tree.
238 if [ ! -f gcc
/version.c
]; then
239 echo "This does not seem to be a GCC tree!"
251 # First of all, check whether we are going to process a patch.
253 if test "$#" != 2; then
254 echo "$1" expects only one argument
>&2
262 if test "$#" != 1; then
263 echo "$1" does not expect any argument
>&2
271 if test "$#" != 1; then
272 echo "$1" does not expect any argument
>&2
275 files_and_dependencies |
sed 's/ /: /'
280 sed -e '1,2d' -e '/^UPDATE_OPTIONS=/{i\
285 -e '/^$/,$d' -e 's/#//' -e 's/^ //' < $0
291 # Check for known version control systems.
293 GCC_GIT
=${GCC_GIT-${GIT-git}}
295 elif [ -d .hg
]; then
296 GCC_HG
=${GCC_HG-${HG-hg}}
298 elif [ -d .svn
]; then
299 GCC_SVN
=${GCC_SVN-${SVN-svn}}
302 echo "This does not seem to be a GCC GIT/HG/SVN tree!"
306 # Check command-line options
307 if [ x
"${1}"x
= x
"--nostdflags"x
]; then
310 set -- $UPDATE_OPTIONS ${1+"$@"}
315 chat
"Updating GIT tree"
317 $GCC_GIT diff --quiet --exit-code HEAD
318 if [ $?
-ne 0 ]; then
319 echo "Attempting to update a dirty git tree!" >&2
320 echo "Commit or stash your changes first and retry." >&2
324 $GCC_GIT pull
${silent+-q} --rebase ${1+"$@"}
325 if [ $?
-ne 0 ]; then
327 echo "git pull of full tree failed." >&2
331 revision
=`$GCC_GIT log -n1 --pretty=%p:%t:%H`
332 branch
=`$GCC_GIT name-rev --name-only HEAD || :`
336 chat
"Updating HG tree"
338 # Add -q so untracked files aren't listed.
339 if [ `$GCC_HG status -q | wc -l` -gt 0 ]; then
340 echo "Attempting to update a dirty hg tree!" >&2
341 echo "Commit or revert your changes first and retry." >&2
345 # Check for mq extension. mq patches must be popped so tip has
346 # been converted from the SVN tree.
347 if [ -d .hg
/patches
] && [ `$GCC_HG qapplied | wc -l` -gt 0 ]; then
348 # FIXME: Perhaps pop queue instead? We could do that since we
349 # know the tree is clean.
350 echo "Attempting to update hg tree with mq patches applied!" >&2
351 echo "Pop your patches first and retry." >&2
355 # Update tree, but make sure to only pull the default branch.
356 # Otherwise all branches in the upstream repo are added, even if
357 # only a single one has been cloned.
358 $GCC_HG pull
${silent+-q} -r`$GCC_HG branch` ${1+"$@"}
359 if [ $?
-ne 0 ]; then
361 echo "hg pull of full tree failed." >&2
365 # Update tree. Needs to be done separately from pull so
366 # gcc_update -rREV works.
367 $GCC_HG update
${silent+-q} ${1+"$@"}
368 if [ $?
-ne 0 ]; then
370 echo "hg update of full tree failed." >&2
374 # Extract SVN revision corresponding to parents, as stored by
375 # hg convert. Before hg 1.4.3, there's no template keyword
376 # corresponding to the extra: tag, so need to use hg log --debug
377 # to extract the info.
378 parents
=`$GCC_HG parents --template '{rev}'`
379 convert_revision
=`$GCC_HG log --debug -r$parents | \
380 sed -ne "/^extra:.*convert_revision=svn:/ {
384 revision
=`echo $convert_revision | sed -e 's/.*@//'`
385 branch
=`echo $convert_revision | sed -e 's%branches/%%' -e 's/@.*//'`
389 chat
"Updating SVN tree"
391 $GCC_SVN ${silent+-q} --non-interactive update
${1+"$@"}
392 if [ $?
-ne 0 ]; then
394 echo "SVN update of full tree failed." >&2
398 revision
=`$GCC_SVN info | awk '/Revision:/ { print $2 }'`
399 branch
=`$GCC_SVN info | sed -ne "/^URL:/ {
408 rm -f LAST_UPDATED gcc
/REVISION
411 echo "`TZ=UTC date` (revision $revision)"
413 echo "[$branch revision $revision]" > gcc
/REVISION